/*
Copyright (C) JAEHYUK CHO
All rights reserved.
Code by JaeHyuk Cho <mailto:minzkn@minzkn.com>

- Simple is best !
*/

#if !defined(__def_mzapi_source_base64_c__)
#define __def_mzapi_source_base64_c__ "base64.c"

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <malloc.h>

#if !defined(__mzapi_peek_vector__)
# define __mzapi_peek_vector__(m_cast,m_base,m_sign,m_offset)         ((m_cast)(((unsigned char *)(m_base)) m_sign (size_t)(m_offset)))
#endif
#if !defined(__mzapi_peek_const_vector__)
# define __mzapi_peek_const_vector__(m_cast,m_base,m_sign,m_offset)         ((m_cast)(((const unsigned char *)(m_base)) m_sign (size_t)(m_offset)))
#endif
#if !defined(mzapi_peek_byte)
# define mzapi_peek_byte(m_base,m_offset)                             (*__mzapi_peek_const_vector__(const unsigned char *,m_base,+,m_offset))
#endif
#if !defined(mzapi_poke_byte)
# define mzapi_poke_byte(m_base,m_offset,m_value)                     (*__mzapi_peek_vector__(unsigned char *,m_base,+,m_offset)) = (unsigned char)(m_value)
#endif

static unsigned long __mzapi_decode_base64__(int s_character);
char * mzapi_encode_base64(const char * s_string, size_t s_length);
char * mzapi_decode_base64(const char * s_string, size_t *s_size);
int main(int s_argc, char **s_argv);

static unsigned long __mzapi_decode_base64__(int s_character)
{
#if 0L
    if((s_character) >= ((int)'a'))return((((unsigned long)(s_character)) - ((unsigned long)'a')) + 26lu);
    else if((s_character) == ((int)'_'))return(63lu);
    else if((s_character) >= ((int)'A'))return(((unsigned long)(s_character)) - ((unsigned long)'A'));
    else if((s_character) >= ((int)'0'))return((((unsigned long)(s_character)) - ((unsigned long)'0')) + 52lu);
    else if(((s_character) == ((int)'+')) || ((s_character) == ((int)'-')))return(62lu);
    else if((s_character) == ((int)'/'))return(63lu);

    return(0lu);
#else
    /* {{{ sg_base64_decode_code_table : 43(2BH)='+', 45(2DH)='-', 47(2FH)='/', 48(30H)='0', 65(41H)='A', 95(5FH)='_', 97(61H)='a' */
    static const unsigned char sg_base64_decode_code_table[ /* 128 */ ] = {
        /* 0x00 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x04 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x08 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x0c */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x10 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x14 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x18 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x1c */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x20 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x24 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x28 */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (62) /* + */, 
        /* 0x2c */ (0)  /*   */, (62) /* - */, (0)  /*   */, (63) /* / */, 
        /* 0x30 */ (52) /* 0 */, (53) /* 1 */, (54) /* 2 */, (55) /* 3 */, 
        /* 0x34 */ (56) /* 4 */, (57) /* 5 */, (58) /* 6 */, (59) /* 7 */, 
        /* 0x38 */ (60) /* 8 */, (61) /* 9 */, (0)  /*   */, (0)  /*   */, 
        /* 0x3c */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 
        /* 0x40 */ (0)  /*   */, (0)  /* A */, (1)  /* B */, (2)  /* C */, 
        /* 0x44 */ (3)  /* D */, (4)  /* E */, (5)  /* F */, (6)  /* G */, 
        /* 0x48 */ (7)  /* H */, (8)  /* I */, (9)  /* J */, (10) /* K */, 
        /* 0x4c */ (11) /* L */, (12) /* M */, (13) /* N */, (14) /* O */, 
        /* 0x50 */ (15) /* P */, (16) /* Q */, (17) /* R */, (18) /* S */, 
        /* 0x54 */ (19) /* T */, (20) /* U */, (21) /* V */, (22) /* W */, 
        /* 0x58 */ (23) /* X */, (24) /* Y */, (25) /* Z */, (0)  /*   */, 
        /* 0x5c */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (63) /* _ */, 
        /* 0x60 */ (0)  /*   */, (26) /* a */, (27) /* b */, (28) /* c */, 
        /* 0x64 */ (29) /* d */, (30) /* e */, (31) /* f */, (32) /* g */, 
        /* 0x68 */ (33) /* h */, (34) /* i */, (35) /* j */, (36) /* k */, 
        /* 0x6c */ (37) /* l */, (38) /* m */, (39) /* n */, (40) /* o */, 
        /* 0x70 */ (41) /* p */, (42) /* q */, (43) /* r */, (44) /* s */, 
        /* 0x74 */ (45) /* t */, (46) /* u */, (47) /* v */, (48) /* w */, 
        /* 0x78 */ (49) /* x */, (50) /* y */, (51) /* z */, (0)  /*   */, 
        /* 0x7c */ (0)  /*   */, (0)  /*   */, (0)  /*   */, (0)  /*   */, 

    };
    /* }}} */

    if((s_character < 0) || (s_character >= ((int)sizeof(sg_base64_decode_code_table)))) {
        return(0);
    }
  
    return((unsigned long)sg_base64_decode_code_table[s_character]);
#endif
}

char * mzapi_encode_base64(const char * s_string, size_t s_length)
{
#if 0L /* base64 */
    static const unsigned char c_alpha_table[] = {"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="};
#else /* filename & url safe base64 */
    static const unsigned char c_alpha_table[] = {"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_="};
#endif 
    char * s_result;
    size_t s_source_offset = (size_t)0, s_target_offset = (size_t)0;
    unsigned long s_value;
    int s_quad, s_trip;
    
    s_result = (char *)malloc((((s_length + ((size_t)2)) / ((size_t)3)) << 2) + ((size_t)1));
    if(s_result == ((char *)0))return((char *)0);
    while(s_source_offset < s_length) {
        s_value = ((unsigned long)(mzapi_peek_byte((const void *)s_string, s_source_offset) & ((int)0xff))) << 8;
        if((s_source_offset + ((size_t)1)) < s_length) {
            s_value |= (unsigned long)(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)1)) & ((int)0xff));
            s_trip = (int)1;
        }
        else s_trip = (int)0;
        s_value <<= 8;
        if((s_source_offset + ((size_t)2)) < s_length) {
            s_value |= (unsigned long)(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)2)) & ((int)0xff));
            s_quad = (int)1;
        }
        else s_quad = (int)0;
        mzapi_poke_byte((void *)s_result, s_target_offset + ((size_t)3), (int)c_alpha_table[(s_quad == (int)1) ? (s_value & 0x3flu) : 64]);
        s_value >>= 6;
        mzapi_poke_byte((void *)s_result, s_target_offset + ((size_t)2), (int)c_alpha_table[(s_trip == (int)1) ? (s_value & 0x3flu) : 64]);
        s_value >>= 6;
        mzapi_poke_byte((void *)s_result, s_target_offset + ((size_t)1), (int)c_alpha_table[s_value & 0x3flu]);
        s_value >>= 6;
        mzapi_poke_byte((void *)s_result, s_target_offset, (int)c_alpha_table[s_value & 0x3flu]);
        s_source_offset += (size_t)3, s_target_offset += (size_t)4;
    }
    mzapi_poke_byte((void *)s_result, s_target_offset, (int)'\0');

    return(s_result);
}

char * mzapi_decode_base64(const char * s_string, size_t *s_size)
{
    char * s_result;
    size_t s_length = strlen(s_string), s_source_offset = (size_t)0, s_target_offset = (size_t)0;
    unsigned long s_value;
    
    if(s_size != ((size_t *)0))*(s_size) = (size_t)0;
    s_result = (char *)malloc((((s_length + ((size_t)3)) >> 2) * ((size_t)3)) + ((size_t)1));
    if(s_result == ((char *)0))return((char *)0);
    while(s_source_offset < s_length) {
        s_value  = ((__mzapi_decode_base64__(mzapi_peek_byte((const void *)s_string, s_source_offset)) & 0x3flu) << 18) |
                   ((__mzapi_decode_base64__(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)1))) & 0x3flu) << 12) |
                   ((__mzapi_decode_base64__(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)2))) & 0x3flu) << 6) |
                   (__mzapi_decode_base64__(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)3))) & 0x3flu);
        mzapi_poke_byte((void *)s_result, s_target_offset++, (int)((s_value >> 16) & 0xfflu));
        if(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)2)) != ((int)'=')) {
            mzapi_poke_byte((void *)s_result, s_target_offset++, (int)((s_value >> 8) & 0xfflu));
            if(mzapi_peek_byte((const void *)s_string, s_source_offset + ((size_t)3)) != ((int)'='))mzapi_poke_byte((void *)s_result, s_target_offset++, (int)(s_value & 0xfflu));
        }
        s_source_offset += (size_t)4;
    }
    mzapi_poke_byte((void *)s_result, s_target_offset, (int)'\0');
    if(s_size != ((size_t *)0))*(s_size) = s_target_offset;

    return(s_result);
}

int main(int s_argc, char **s_argv)
{
    static char s_default[] = {
        "Copyright (c) HWPORT.COM All rights reserved.\n"
    };
    char *s_this;
    size_t s_decode_size;
 
    if(s_argc >= 2)s_this = (char *)(&s_argv[1][0]);
    else s_this = s_default;
 
    (void)fprintf(stdout, "original: {\n%s} (%d)\n\n", s_this, (int)strlen(s_this));

#if 1
    do {
        char *s_encode, *s_decode;

        s_encode = mzapi_encode_base64(s_this, strlen(s_this));
        if(s_encode == ((char *)0))return(1); /* error */
        (void)fprintf(stdout, "encode  : \"%s\" (%d)\n\n", s_encode, (int)strlen(s_encode));
    
        s_decode = mzapi_decode_base64(s_encode, (size_t *)(&s_decode_size));
        if(s_decode == ((char *)0)) { /* error */
            free((void *)s_encode);
            return(1);
        }
        (void)fprintf(stdout, "decode  : {\n%s} (%d / %lu)\n\n", s_decode, (int)strlen(s_decode), (unsigned long)s_decode_size);
  
        free((void *)s_decode);
        free((void *)s_encode);
    }while(0);
#else
    do {
        char *s_decode;

        s_decode = mzapi_decode_base64(s_this, (size_t *)(&s_decode_size));
        if(s_decode == ((char *)0)) { /* error */
            return(1);
        }
        (void)fprintf(stdout, "decode  : {\n%s} (%d / %lu)\n\n", s_decode, (int)strlen(s_decode), (unsigned long)s_decode_size);
  
        free((void *)s_decode);
    }while(0);
#endif
    return(0);
}

#endif

/* End of source */ 
